$regfile = "m168def.dat"
$crystal = 11059200
$baud = 4800                                                '      

$hwstack = 120                                              ' default
$swstack = 120                                              ' default
$framesize = 180

' 
Declare Sub Getline(s As String)
Declare Sub Flushbuf()                                      ' 

 '  
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
Config Portc.2 = Output
Speaker Alias Portc.2
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


Dim Timeout As Byte


Config Serialin = Buffered , Size = 20

' 
Config Adc = Single , Prescaler = Auto , Reference = Internal



Config Portb.5 = Output                                     ' 
Led Alias Portb.5
Led = 1

Config Portd.5 = Output                                     ' 
Led_ind Alias Portd.5
Led_ind = 0



' I/O  3310
'========================================================================================
'========================================================================================
Config Portb.0 = Output                                     'D/C (pin 4)
D3310dc Alias Portb.0
Config Portd.7 = Output                                     'CE (pin 5)
D3310ce Alias Portd.7
Config Portd.6 = Output                                     'Reset (pin 8)
D3310re Alias Portd.6
' SPI   . SCLK (pin 2) - PORTA.2; SDA (pin 3) - PORTA.1; Din  
Config Spi = Soft , Din = Portd.4 , Dout = Portb.1 , Ss = None , Clock = Portb.2
Spiinit
$include "3310init.bas"

' SPI
Call D3310reset
Call D3310init
Call D3310clear



'     
Dim A As String * 14
Dim B As String * 14
Dim C As String * 14
Dim D As String * 14
Dim E As String * 14


'      
Dim B1 As String * 14
Dim C1 As String * 14
Dim D1 As String * 14
Dim E1 As String * 14



Dim I As Word
Dim Istr As String * 4



Dim W As Word                                               ' 
Dim Wsingl As Single
Dim Wstr As String * 5

Dim Baudstr As String * 6                                   '      


Dim S As String * 14                                        ' 
Dim N As Byte                                               '    ASCII
Dim R As Byte                                               '  


Dim T As Byte                                               '   



 Dim Flag As Byte                                           '    
  Flag = 0



Config Int0 = Falling
Config Int1 = Falling
On Int0 Light                                               '  
On Int1 Uv                                                  '    








'////////////////////////////////////////////////////////////
'    
Dim Baud_eep As Eram Long
Dim Baud_1 As Long

Baud_1 = Baud_eep                                           '    



If Baud_1 = -1 Then                                         '        
 Baud_1 = 4800                                              '     (     )
Else
Select Case Baud_1                                          '     
  Case 4800 : Baud = 4800
  Case 9600 : Baud = 9600
  Case 19200 : Baud = 19200
  Case 38400 : Baud = 38400
  Case 115200 : Baud = 115200
End Select
End If
'////////////////////////////////////////////////////////////









'    

Restore D3310bmp12
Call D3310bmpout

Wait 2
Sound , Speaker , 100 , 500
Waitms 30
Sound , Speaker , 100 , 500
Waitms 30
Sound , Speaker , 100 , 500

Waitms 300





Call D3310clear

Istr = "0000"
Flushbuf



Enable Int0
Enable Int1
Enable Interrupts                                           ' 





Do



If Flag = 0 Then                                            '      


R = Ischarwaiting()                                         '    

  If R = 1 Then
     Led_ind = 1
     Getline S                                              '      
     Flushbuf

     Incr I                                                 '   
     Istr = Str(i)
     Istr = Format(istr , "0000")                           '    


Incr T

If T = 1 Then
 A = S
End If

If T = 2 Then
 B = S
End If

If T = 3 Then
 C = S
End If

If T = 4 Then
 D = S
End If

If T = 5 Then
 E = S
End If


'     

If T > 5 Then                                               '   ,    

 A = B
 B = C
 C = D
 D = E

 E = S

End If

Led_ind = 0

End If





Call D3310clear                                             ' 

Call D3310position(0 , 0)                                   '   
Call D3310print(a)

Call D3310position(0 , 1)                                   '   
Call D3310print(b)

Call D3310position(0 , 2)                                   '   
Call D3310print(c)

Call D3310position(0 , 3)                                   '   
Call D3310print(d)

Call D3310position(0 , 4)                                   '   
Call D3310print(e)

Call D3310position(10 , 5)                                  '   
Call D3310print(istr)




 Else                                                       '     0    

   If Flag = 1 Then
     Restore D3310bmp1
     Call D3310bmpout
   End If

   If Flag = 2 Then
     Restore D3310bmp2
     Call D3310bmpout
   End If


   If Flag = 3 Then
     Restore D3310bmp3
     Call D3310bmpout
   End If


   If Flag = 4 Then
     Restore D3310bmp4
     Call D3310bmpout
   End If


   If Flag = 5 Then
     Restore D3310bmp5
     Call D3310bmpout
   End If


 End If




Waitms 500



Loop


End

$include "3310bmp1.bas"                                     '  
$include "3310bmp2.bas"                                     '   
$include "3310bmp3.bas"
$include "3310bmp4.bas"
$include "3310bmp5.bas"

$include "3310bmp11.bas"                                    '
$include "3310bmp12.bas"                                    '
$include "3310bmp13.bas"                                    '

$include "3310end.bas"





Uv:                                                         '    

Waitms 5

If Flag = 0 Then                                            '    

Do

Start Adc
W = Getadc(0)
Wsingl = W / 238                                            '       


Wstr = Fusing(wsingl , "#.##")
Wstr = Wstr + "v"

Baudstr = Str(baud_1)


Restore D3310bmp13
Call D3310bmpout

Call D3310position(6 , 1)
'Call D3310position(5 , 3)
Call D3310print(wstr)

Call D3310position(6 , 3)
Call D3310print(baudstr)


Waitms 700


   If Pind.2 = 0 Then                                       '           
    Waitms 5
    Flag = 1
    Sound , Speaker , 100 , 500
    Sound , Speaker , 100 , 200
    Sound , Speaker , 100 , 500
    Goto Ex
    Eifr = 1
   End If


Incr Timeout
 If Timeout > 10 Then                                       '  7 ...

  Sound , Speaker , 300 , 700

  Do
  Restore D3310bmp11
  Call D3310bmpout


  Loop
 End If



Loop Until Pind.3 = 1                                       '    

Timeout = 0                                                 ' 

  Ex:

Stop Adc
Waitms 5
Eifr = 2
Call D3310clear

Else                                                        '  ,       
Waitms 300

Sound , Speaker , 100 , 500

Incr Flag
 If Flag > 5 Then
  Flag = 1
End If

Eifr = 2

End If





Return





Light:                                                      ' 

If Flag = 0 Then                                            '      
 Toggle Led

 Else                                                       '            

 Select Case Flag                                           '     
  Case 1 : Baud = 4800
  Case 2 : Baud = 9600
  Case 3 : Baud = 19200
  Case 4 : Baud = 38400
  Case 5 : Baud = 115200

 End Select

 If Pind.3 = 1 Then

 Select Case Flag                                           '      
  Case 1 : Baud_1 = 4800
  Case 2 : Baud_1 = 9600
  Case 3 : Baud_1 = 19200
  Case 4 : Baud_1 = 38400
  Case 5 : Baud_1 = 115200
 End Select

 Baud_eep = Baud_1                                          '  EEPROM

Sound , Speaker , 400 , 500


  Flag = 0                                                  ' 
 End If


 End If

Waitms 250
Eifr = 1



Return





'    
'=============================================================================
Sub Getline(s As String)

   S = ""
   N = Inkey()
   If N <> 10 Then                                          '    
   $timeout = 1000000                                       '
   Input S Noecho                                           '   
   If N <> 10 Then S = Chr(n) + S                           ' 
   End If

End Sub                                                     '



' 
'=============================================================================
Sub Flushbuf()
 Waitms 10
 Do
 N = Inkey()                                                '   
 Loop Until N = 0
End Sub